unit berkut_unit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls,

  t2port,cplist, // COMPORT

  math; // LOG10()

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Button1: TButton;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Button2: TButton;
    CheckBox1: TCheckBox;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    RadioGroup3: TRadioGroup;
    TrackBar1: TTrackBar;
    Label3: TLabel;
    Button3: TButton;
    Edit3: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    RadioGroup4: TRadioGroup;
    RadioGroup5: TRadioGroup;
    procedure CheckBox1click(Sender: TObject);
    procedure form1create(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure TrackBarChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

type
  TMyThread = class(TThread)
  protected
    procedure Execute; override;
  public
    constructor Create(CreateSuspended: boolean);
  end;

var MyThread : TMyThread;


var
  Form1: TForm1;


  // COM PORT
  myPort: TComPort;

  // CONFIGURATION
  var AnswerLength:word;
  var SerialNumber:word;
  var Regim:word;
  var Baffle:word;
  var CS:byte;


  var SpeedKMH: Boolean;
  var SpeedMPH: Boolean;

  var Stationary: Boolean;
  var Patrol: Boolean;

  var Oncoming: Boolean;
  var Outgoing: Boolean;

  var Car1fastest: Boolean;
  var Car1strongest: Boolean;

  var Car2fastest: Boolean;
  var Car2strongest: Boolean;

  var dB:integer;


implementation

{$R *.dfm}



procedure TMyThread.Execute;
var temp:TBufferType;
begin

  while (not Terminated) do
   begin

   myPort.SendData('21 06');

     if myPort.GetDataLTime(4,temp,'21',50) then
      case temp[1] of
       0: begin
           Form1.Edit1.Text:='-';
           Form1.Edit2.Text:='-';
          end;
       1: begin
           Form1.Edit1.Text:=IntToStr(temp[2]);
           Form1.Edit2.Text:='-';
          end;
       2: begin
           Form1.Edit1.Text:=IntToStr(temp[2]);
           Form1.Edit2.Text:=IntToStr(temp[3]);
          end;
      end;

      sleep(50);
      Application.ProcessMessages;

   end;
end;

constructor TMyThread.Create(CreateSuspended: boolean);
begin
  FreeOnTerminate := True;
  inherited Create(CreateSuspended);
end;



procedure TForm1.Button1Click(Sender: TObject);
var portList:TStringList;
    i:integer;
    temp:TBufferType;
begin

 
 portList:=TStringList.Create;
 GetPortList(portList);

 for i := 0 to portList.Count-1 do
  begin
   myPort.OpenPort(portList[i]);

   // Write: "80"
   // Read: "A7"
   myPort.SendData('80');
   if myPort.GetDataLTime(1,temp,'A7',50) then
    begin
     Button1.Caption:='Berkut connected to: '+portList[i];

     // Write "21 03"
     // Read "03 .. .. .. .. .. .. .. .."
     myPort.SendData('21 03');
     if myPort.GetDataLTime(8,temp,'03',50) then
      begin

       AnswerLength:=(Temp[0] + (Temp[1] shl 8));
       SerialNumber:=(Temp[2] + (Temp[3] shl 8));
       Regim:=(Temp[4] + (Temp[5] shl 8));
       Baffle:= (Temp[6] + (Temp[7] shl 8));
       CS:= Temp[8];


       SpeedKMH:=not Boolean(Regim and $0001);
       SpeedMPH:=not SpeedKMH;

       Stationary:=not Boolean((Regim shr 1) and $0001);
       Patrol:=not Stationary;

       Oncoming:=not Boolean((Regim shr 2) and $0001);
       Outgoing:=not Oncoming;

       Car1fastest:=not Boolean((Regim shr 8) and $0001);
       Car1strongest:=not Car1fastest;

       Car2fastest:=not Boolean((Regim shr 9) and $0001);
       Car2strongest:=not Car2fastest;

       dB:=round(20*log10(Baffle/32768));


       // TFORM1
       if SpeedKMH then RadioGroup5.ItemIndex:=0;
       if SpeedMPH then RadioGroup5.ItemIndex:=1;

       if Stationary then RadioGroup1.ItemIndex:=0;
       if Patrol then RadioGroup1.ItemIndex:=1;

       if Oncoming then RadioGroup2.ItemIndex:=0;
       if Outgoing then RadioGroup2.ItemIndex:=1;

       if Car1fastest then RadioGroup3.ItemIndex:=0;
       if Car1strongest then RadioGroup3.ItemIndex:=1;

       if Car2fastest then RadioGroup4.ItemIndex:=0;
       if Car2strongest then RadioGroup4.ItemIndex:=1;

       TrackBar1.Position:=dB;

       GroupBox1.Enabled:=false;
       GroupBox2.Enabled:=true;
       GroupBox3.Enabled:=true;

       exit;  // RADAR FOUND

      end;


    end;



   myPort.ClosePort;

   Application.ProcessMessages;
  end;

  showMessage('Radar not found!');

end;

procedure TForm1.Button2Click(Sender: TObject);
var temp:TBufferType;
begin
     myPort.SendData('21 06');

     if myPort.GetDataLTime(4,temp,'21',50) then
      case temp[1] of
       0: begin
           Edit1.Text:='-';
           Edit2.Text:='-';
          end;
       1: begin                           
           Edit1.Text:=IntToStr(temp[2]);
           Edit2.Text:='-';
          end;
       2: begin
           Edit1.Text:=IntToStr(temp[2]);
           Edit2.Text:=IntToStr(temp[3]);
          end;
      end;

end;

procedure TForm1.Button3Click(Sender: TObject);
var temp:TBufferType;
begin
SpeedKMH:=true;
Stationary:=true;
Oncoming:=true;
Car1fastest:=true;
Car2fastest:=true;

if RadioGroup5.ItemIndex=1 then SpeedKMH:=false;
if RadioGroup1.ItemIndex=1 then Stationary:=false;
if RadioGroup2.ItemIndex=1 then Oncoming:=false;
if RadioGroup3.ItemIndex=1 then Car1fastest:=false;
if RadioGroup4.ItemIndex=1 then Car2fastest:=false;


SpeedMPH:=not SpeedKMH;
Patrol:=not Stationary;
Outgoing:=not Oncoming;
Car1strongest:=not Car1fastest;
Car2strongest:=not Car2fastest;

dB:=TrackBar1.Position;


// WRITE COM PORT

AnswerLength:=$0003;
SerialNumber:=$0000;
Regim:=$0000 + Byte(SpeedMPH)
             + (Byte(Patrol) shl 1)
             + (Byte(Outgoing) shl 2)
             + (Byte(Car1strongest) shl 8)
             + (Byte(Car2strongest) shl 9);

Baffle:=trunc(32768*power(10,dB / 20));


temp[0]:=$21;
temp[1]:=$04;
temp[2]:=$03;
temp[3]:=$00;

temp[4]:=SerialNumber and $ff;
temp[5]:=(SerialNumber shr 8) and $ff;

temp[6]:=Regim and $ff;
temp[7]:=(Regim shr 8) and $ff;

temp[8]:=Baffle and $ff;
temp[9]:=(Baffle shr 8) and $ff;

myPort.SendDataBinary(temp,10);

if not myPort.GetDataLTime(1,temp,'',50) then
 showMessage('Error writing configuration!')
  else
 showMessage('Configuration saved');
  
end;

procedure TForm1.CheckBox1click(Sender: TObject);
begin

if checkBox1.Checked then MyThread.Resume
 else MyThread.Suspend;


end;

procedure TForm1.form1create(Sender: TObject);
begin

   MyThread := TMyThread.Create(True);
   MyThread.Priority:=tpLower;

end;

procedure TForm1.TrackBarChange(Sender: TObject);
begin
 Edit3.Text:=IntToStr(TrackBar1.Position);
end;

end.
